# Source code

    001/*
    002 * Licensed to the Apache Software Foundation (ASF) under one
    003 * or more contributor license agreements.  See the NOTICE file
    004 * distributed with this work for additional information
    005 * regarding copyright ownership.  The ASF licenses this file
    006 * to you under the Apache License, Version 2.0 (the
    007 * "License"); you may not use this file except in compliance
    008 * with the License.  You may obtain a copy of the License at
    009 *
    010 * http://www.apache.org/licenses/LICENSE-2.0
    011 *
    012 * Unless required by applicable law or agreed to in writing,
    013 * software distributed under the License is distributed on an
    014 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    015 * KIND, either express or implied.  See the License for the
    016 * specific language governing permissions and limitations
    017 * under the License.
    018 */
    019package org.apache.commons.compress.compressors.lzma;
    020
    021import java.util.HashMap;
    022import java.util.Map;
    023import org.apache.commons.compress.compressors.FileNameUtil;
    024
    025/**
    026 * Utility code for the lzma compression format.
    027 * @ThreadSafe
    028 * @since 1.10
    029 */
    030public class LZMAUtils {
    031
    032    private static final FileNameUtil fileNameUtil;
    033
    034    /**
    035     * LZMA Header Magic Bytes begin a LZMA file.
    036     */
    037    private static final byte[] HEADER_MAGIC = {
    038        (byte) 0x5D, 0, 0
    039    };
    040
    041    static enum CachedAvailability {
    042        DONT_CACHE, CACHED_AVAILABLE, CACHED_UNAVAILABLE
    043    }
    044
    045    private static volatile CachedAvailability cachedLZMAAvailability;
    046
    047    static {
    048        final Map<String, String> uncompressSuffix = new HashMap<>();
    049        uncompressSuffix.put(".lzma", "");
    050        uncompressSuffix.put("-lzma", "");
    051        fileNameUtil = new FileNameUtil(uncompressSuffix, ".lzma");
    052        cachedLZMAAvailability = CachedAvailability.DONT_CACHE;
    053        try {
    054            Class.forName("org.osgi.framework.BundleEvent");
    055        } catch (final Exception ex) {
    056            setCacheLZMAAvailablity(true);
    057        }
    058    }
    059
    060    /** Private constructor to prevent instantiation of this utility class. */
    061    private LZMAUtils() {
    062    }
    063
    064    /**
    065     * Checks if the signature matches what is expected for a .lzma file.
    066     *
    067     * @param   signature     the bytes to check
    068     * @param   length        the number of bytes to check
    069     * @return  true if signature matches the .lzma magic bytes, false otherwise
    070     */
    071    public static boolean matches(final byte[] signature, final int length) {
    072        if (length < HEADER_MAGIC.length) {
    073            return false;
    074        }
    075
    076        for (int i = 0; i < HEADER_MAGIC.length; ++i) {
    077            if (signature[i] != HEADER_MAGIC[i]) {
    078                return false;
    079            }
    080        }
    081
    082        return true;
    083    }
    084
    085    /**
    086     * Are the classes required to support LZMA compression available?
    087     * @return true if the classes required to support LZMA
    088     * compression are available
    089     */
    090    public static boolean isLZMACompressionAvailable() {
    091        final CachedAvailability cachedResult = cachedLZMAAvailability;
    092        if (cachedResult != CachedAvailability.DONT_CACHE) {
    093            return cachedResult == CachedAvailability.CACHED_AVAILABLE;
    094        }
    095        return internalIsLZMACompressionAvailable();
    096    }
    097
    098    private static boolean internalIsLZMACompressionAvailable() {
    099        try {
    100            LZMACompressorInputStream.matches(null, 0);
    101            return true;
    102        } catch (final NoClassDefFoundError error) {
    103            return false;
    104        }
    105    }
    106
    107    /**
    108     * Detects common lzma suffixes in the given filename.
    109     *
    110     * @param filename name of a file
    111     * @return {@code true} if the filename has a common lzma suffix,
    112     *         {@code false} otherwise
    113     */
    114    public static boolean isCompressedFilename(final String filename) {
    115        return fileNameUtil.isCompressedFilename(filename);
    116    }
    117
    118    /**
    119     * Maps the given name of a lzma-compressed file to the name that
    120     * the file should have after uncompression.  Any filenames with
    121     * the generic ".lzma" suffix (or any other generic lzma suffix)
    122     * is mapped to a name without that suffix. If no lzma suffix is
    123     * detected, then the filename is returned unmapped.
    124     *
    125     * @param filename name of a file
    126     * @return name of the corresponding uncompressed file
    127     */
    128    public static String getUncompressedFilename(final String filename) {
    129        return fileNameUtil.getUncompressedFilename(filename);
    130    }
    131
    132    /**
    133     * Maps the given filename to the name that the file should have after
    134     * compression with lzma.
    135     *
    136     * @param filename name of a file
    137     * @return name of the corresponding compressed file
    138     */
    139    public static String getCompressedFilename(final String filename) {
    140        return fileNameUtil.getCompressedFilename(filename);
    141    }
    142
    143    /**
    144     * Whether to cache the result of the LZMA check.
    145     *
    146     * <p>This defaults to {@code false} in an OSGi environment and {@code true} otherwise.</p>
    147     * @param doCache whether to cache the result
    148     */
    149    public static void setCacheLZMAAvailablity(final boolean doCache) {
    150        if (!doCache) {
    151            cachedLZMAAvailability = CachedAvailability.DONT_CACHE;
    152        } else if (cachedLZMAAvailability == CachedAvailability.DONT_CACHE) {
    153            final boolean hasLzma = internalIsLZMACompressionAvailable();
    154            cachedLZMAAvailability = hasLzma ? CachedAvailability.CACHED_AVAILABLE
    155                : CachedAvailability.CACHED_UNAVAILABLE;
    156        }
    157    }
    158
    159    // only exists to support unit tests
    160    static CachedAvailability getCachedLZMAAvailability() {
    161        return cachedLZMAAvailability;
    162    }
    163}